#!/usr/bin/perl

%v = &GetCgiVars;
$img = $v{'img'};
$author = $v{'email'};
if ($author eq "") {
  $author = "mira\@sirrah.troja.mff.cuni.cz";
}

print <<EOF ;
Content-type: text/html

<html>
<head>
<title>Obr. $img</title>
<meta http-equiv="Content-type" content="text/html" charset="iso-8859-2">
</head>
<body>


<table cellpadding=6 cellspacing=0 border=1>
<tr>
<td colspan="2"><font face="Arial,Helvetica">Obr. <b>$img</b></font></td>
</tr>
<tr>
<td bgcolor="white"><img src="$img.gif"></td>
<td valign="top">
<table cellpadding=1 cellspacing=0 border=0>
<tr>
<td><a href="$img.mp"><font face="Arial,Helvetica">MetaPost zdroj</font></a></td>
<tr>
</tr>
<td><a href="$img.1"><font face="Arial,Helvetica">PS pro dvips</font></a></td>
<tr>
</tr>
<td><a href="$img.eps"><font face="Arial,Helvetica">EPS</a></font></td>
<tr>
</tr>
<td><a href="$img.gif"><font face="Arial,Helvetica">obrzek GIF</font></a></td>
</tr>
</table>

<font face="Arial,Helvetica">
<p>mail <a href="mailto:$author">autorovi</a></font>
</td>
</tr>
</table>
</font>

</body>
</html>

EOF

exit;

sub GetCgiVars {
    local($in, %in) ;
    local($name, $value) ;


    # First, read entire string of CGI vars into $in
    if ($ENV{'REQUEST_METHOD'} eq 'GET') {
        $in = $ENV{'QUERY_STRING'} ;

    } elsif ($ENV{'REQUEST_METHOD'} eq 'POST') {
        if ($ENV{'CONTENT_TYPE'}=~ m#^application/x-www-form-urlencoded$#i) {
            $ENV{'CONTENT_LENGTH'}
                || &PukeOnEm("No Content-Length sent with the POST request.");
            read(STDIN, $in, $ENV{'CONTENT_LENGTH'}) ;

        } else {
            &PukeOnEm("Unsupported Content-Type: $ENV{'CONTENT_TYPE'}") ;
        }

    } else {
        &PukeOnEm("Script was called with unsupported REQUEST_METHOD.") ;
    }

    # Resolve and unencode name/value pairs into %in
    foreach (split('&', $in)) {
        s/\+/ /g ;
        ($name, $value)= split('=', $_, 2) ;
        $name=~ s/%(..)/sprintf("%c",hex($1))/ge ;
        $value=~ s/%(..)/sprintf("%c",hex($1))/ge ;
        $in{$name}.= "\0" if defined($in{$name}) ;  # concatenate multiple var
        $in{$name}.= $value ;
    }

    return %in ;
}


# Die, outputting HTML error page
# If no $title, use a default title
sub PukeOnEm {
    local($msg,$title)= @_ ;
    $title || ($title= "CGI Error") ;
    print <<EOF ;
Content-type: text/html

<html>
<head>
<title>$title</title>
</head>
<body>
<h1>$title</h1>
<h3>$msg</h3>
<P>
<address>
Miroslav Broz, <a href="mailto:miroslav.broz\@usa.net">miroslav.broz\@usa.net</a>, Apr 8th 1998
</address>
</body>
</html>
EOF

    exit ;
}

###
# This sub disables HTML tags.  It will convert
# <> to &lt, &gt, in affect, making the tag appear
# to the reader as it was typed.
# It works like this: $myvarible = &RemoveHTML($myvarible);
#########################################################

sub RemoveHTML {
        local($input) = @_;
        $_ = $input;
        s/\</\&lt\;\&nbsp/g;
        s/\>/\&gt\;\&nbsp/g;
        $output = $_;
        return $output;
}

